""" defworld.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from world import world
from know import know
from thing import thing
from body import body
from mind import mind
from house import house
from event import *
import wtime,mgoal,prob

#If you want to mail annoucements to cyphesis-snapshot, you must first
#subscribe to cyphesis-devel@lists.1ststep.net
#ALL discussion should go to cyphesis@lists.1ststep.net

#To subscribe send message to cyphesis-devel-request@lists.1ststep.net
#with text "subscribe" in the body of message.

village_height=300
smithy_xyz=(20,10,village_height+5)
forest_xyz=(150,-50,village_height-50)
tavern_xyz=(50,30,village_height-5)

knowledge=[('axe','smithy'),
           ('smithy',smithy_xyz),
           ('forest',forest_xyz),
           ('tavern',tavern_xyz)]

goals=[('breakfast',"imaginary('have a breakfast', 'morning', 'home')"),
       ('dinner',"imaginary('have a dinner', 'midday', 'home')"),
       ('supper',"imaginary('have a supper', 'evening', 'home')"),
       ('sleep',"imaginary('sleep good night', 'night', 'home')"),
       ('build home',"build_home")]

class editor:
    def __init__(self,m):
        self.m=m
    def make(self, id, **kw):
        return apply(self.m.make,(id,),kw)
    def say(self,target,verb,subject,object):
        if type(target)==ListType:
            for t in target:
                self.say(t,verb,subject,object)
        else:
            es=esay(verb=verb,subject=subject,object=object)
            self.m.send_events([event('say',what=es,target=target)])
    def own(self,target,object):
        if type(target)!=ListType: target=[target]
        if type(object)!=ListType: object=[object]
        for t in target:
            for o in object:
                self.say(t,'own',t,o)
    def know(self,target,know):
        if type(target)!=ListType: target=[target]
        if type(know)!=ListType: know=[know]
        for t in target:
            for k in know:
                self.say(t,'know',k[0],k[1])
    def learn(self,target,goal):
        if type(target)!=ListType: target=[target]
        if type(goal)!=ListType: goal=[goal]
        for t in target:
            for g in goal:
                self.say(t,'learn',g[0],g[1])

#observer calls this
def default(mapeditor):
    #general things
    #Names by "Khilghard" <Drachenberg@earthlink.net>

    m=editor(mapeditor)



    #farmers

    home_xyz=(20,50,village_height)

    home=m.make('house',type='house',desc='ordinary house',
                place='home',xyz=home_xyz)
    axe=m.make('axe',desc='normal axe good for cutting trees',place='forest',
               xyz=forest_xyz,status=1.0)

    farmer1=m.make('Nisuf',type='farmer',desc='ordinary farmer',
                   xyz=home_xyz,age=prob.fertility_age,sex='male')
 
    farmer2=m.make('Miyora',type='farmer',sex='female',copy=farmer1)

    farmers=[farmer1,farmer2]

    #teach farmers
    m.own(farmers,home)
    m.own(farmer1,axe)
    m.know(farmers,knowledge)
    m.know(farmers,('home',home_xyz))
    m.know(farmers,('field',(-100,50,village_height)))
    m.learn(farmers,goals)
    m.learn(farmer1,('chop trees',
                     "cut_something(self,'chop trees', 'winter', 'forest','axe')"))


    #smith

    home_xyz=(70,0,village_height)
    home=m.make('house',type='house',desc='ordinary house',
                place='home',xyz=home_xyz)
    smithy=m.make('smithy',type='house',desc='ordinary smithy',place='smithy',
                  status=1.0,xyz=smithy_xyz)
    smith=m.make('Bjorn',type='smith', desc='only smith in village',
                 xyz=home_xyz,
                 place='home', age=prob.fertility_age*2, sex='male')

    #teach smith
    m.own(smith,[home,smithy])
    m.know(smith,knowledge)
    m.know(smith,('home',home_xyz))
    m.learn(smith,goals)
    m.learn(smith,('create axes',
                     "make_amount('axe',10,'ordinary axe','smithy')"))
