""" ext_mind.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

import time, re
from event import *
from imind import imind
import defworld,const

def sc(x,min,max,s):
    res=int(s/(max-min)*(x-min))
    if res<0: res=0
    if res>=s: res=s-1
    return res

class ext_mind(imind):
    def __init__(self, name, remote, invoke_steps=1, type="body",
                 xyz=(-100,-100,-100), ccode=None):
        imind.__init__(self,name,remote,type,xyz=xyz,ccode=ccode)
        self.invoke_steps=invoke_steps
    def step(self):
        if self.invoke_steps:
            self.eng.metaEvent("event('step')")
        else:
            time.sleep(const.client_sleep)
    def run(self, steps=1, display=1, clear_screen=1):
        if display and clear_screen: print chr(27)+"c"
        res=[]
        for i in xrange(steps):
            self.step()
            res=self.receive_events()
            output=self.analyse_input(res)
            self.send_events(output)
            if display: self.display_text_screen()
            else: self.print_events(res)
        return res
    def print_events(self,res):
        print res
        for e in res:
            if e.command=="goal":
                print "goal for",`e.source`+":",e.what_desc
    def dsp(self, steps=1):
        self.run(steps,1)
    def text(self, steps=1):
        self.run(steps,0)
        print self.time
    def display_text_screen(self):
        wait=0.0
        xmin=-300.0
        xmax=-xmin
        ymin=-150.0
        ymax=-ymin
        sizex=49
        sizey=20
        goal_width=30
        def scx(x, min=xmin, max=xmax, s=sizex): return sc(x,min,max,s)
        def scy(y, min=ymin, max=ymax, s=sizey): return sc(-y,min,max,s)
        screen = [None]*sizex
        for i in range(sizex):
            screen[i] = ['.'] * sizey
        smithy_list=[]
        tavern_list=[]
        home_list=[]
        mind_list=[]
        fire_list=[]
        for t in self.map.things.values():
            if t.name=="smithy": smithy_list.append(t)
            elif t.name=="tavern": tavern_list.append(t)
            elif t.name=="house": home_list.append(t)
            elif string.find(t.type,"body")>=0: mind_list.append(t)
            elif t.name=="fire": fire_list.append(t)
        print chr(27)+"[H",self.time,"Count of minds:",len(mind_list)
        for t in smithy_list:
            (x,y,z)=t.get_xyz()
            screen[scx(x)][scy(y)]='s'
        for t in tavern_list:
            (x,y,z)=t.get_xyz()
            screen[scx(x)][scy(y)]='t'
        for t in home_list:
            (x,y,z)=t.get_xyz()
            screen[scx(x)][scy(y)]='h'
        yind=1
        goal_txt={}
        for m in mind_list:
            (x,y,z)=m.get_xyz()
            x,y=scx(x),scy(y)
            screen[x][y]=m.name[0]
            screen[x+1][y]=m.name[-1]
            if hasattr(m,"goal"):
                goal_txt[yind]=(`m`+":"+m.goal+" "*goal_width)[:goal_width]
                yind=yind+1
        for t in fire_list:
            (x,y,z)=t.get_xyz()
            screen[scx(x)][scy(y)]='F'
            wait=0.2
        out=[]
        for y in range(sizey):
            for x in range(sizex):
                out.append(screen[x][y])
            out.append(goal_txt.get(y," "*goal_width))
            out.append('\n')
        print string.join(out,'')
        time.sleep(wait)
