""" imind.py
 Copyright (C) 1998,1999 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

from types import *
import sys,ilu,time,wtime
from engine import engine
from event import *
from vmind import vmind

def get_engine(factoryObjectSID, factoryObjectIH):
    # We have to call ilu.LookupObject() with the object ID of
    # the factory object, and the "type" of the object we're looking
    # for, which is always available as MODULE.TYPENAME

    e = ilu.LookupObject (factoryObjectSID, factoryObjectIH, engine)
    if not e:
        print "Can't find factory instance "+factoryObjectSID+"/"+factoryObjectIH
        sys.exit(1)
    return e

class imind(vmind):
    def __init__(self, name, remote, type, xyz=(-100,-100,-100), ccode=None):
        vmind.__init__(self,name)
        self.ccode=ccode
        self.time=wtime.world_time()
        if remote:
            self.eng=get_engine("cyphesis","engine")
        else:
            self.eng = engine()
        if not self.eng:
            error("Couldn't create engine")
        et=ething(name,type=type,desc='external mind',xyz=xyz)
        self.body=self.eng.createBody(`[event('make',what=et)]`)
        self.id=self.body.getId()
        self.map.things[self.id]=self
        #self.process_events(self.msg("event('load',what='default',loc='debug')"))
    def receive_events(self):
        input=[]
        not_ok=1
        while not_ok:
            time,res=eval(self.body.receive())
            apply(self.time.mktime,time)
            self.replace_illegal_with_destroy(res)
            input=res+input
            try:
                self.map.update(input)
                events_replace_id_with_thing(self,input)
                not_ok=0
            except id_unknown, (id, ev):
                self.body.send("[event('look',what="+`id`+")]")
        return input
    def send_events(self, output):
        self.body.send(`output`)
    #Handle events (method name is: e.command+"_event")
    def fire_event(self,e): 
        if self.ccode:
            (x,y,z)=e.target.get_xyz()
            self.ccode.cfire_event(e.target,x,y,z)
    def say_event(self,e): pass #no action for now
    def make_event(self, e):
        if self.ccode:
            t=e.what
            (x,y,z)=t.get_xyz()
            self.ccode.cmake_event(t.id,t.name,t.type,x,y,z)
    def move_event(self, e):
        t=e.what
        if type(e.loc)==TupleType:
            t.xyz=e.loc
        else:
            t.xyz=None
            t.place=e.loc
        if self.ccode:
            (x,y,z)=t.get_xyz()
            self.ccode.cmove_event(t.id,x,y,z)
    def destroy_event(self, e):
        id=e.what.id
        if self.map.things.has_key(id):
            if self.ccode:
                self.ccode.cdestroy_event(e.what)
            del self.map.things[id]
    def sight_event(self,e):
        t=e.what
        if hasattr(t,"command"):
            return self.analyse_input([t])
    def imaginary_event(self,e): pass
    def change_event(self,e): pass
    def extinguish_event(self,e): pass
    def goal_event(self,e):
        t=e.source
        t.goal=e.what_desc
        if self.ccode:
            self.ccode.cgoal_event(t.id,t.goal)
    def undefined_event(self,e):
        print "Undefined:",`e`
        time.sleep(10)
