""" mem_map.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""
from types import *
from thing import thing
from event import *

class mem_map:
    def __init__(self):
        self.things={}
    def update(self, input):
        for e in input:
            try:
                if e.command=="sight":
                    if hasattr(e.what,"is_event"):
                        e.what.what=self.check(e.what.what)
                    else:
                        e.what=self.check(e.what)
                if e.command=="say" and isinstance(e.what,esay):
                    e.what.subject=self.check(e.what.subject)
                    e.what.object=self.check(e.what.object)
            except id_unknown, id:
                raise id_unknown, (id[0], e)
    def check(self, thing):
        if isinstance(thing,ething):
            try:
                t=self.things[thing.id]
                t.__dict__.update(thing.kw)
                return t
            except KeyError:
                return self.make_thing_from_ething(thing)
        else:
            return thing
    def make_thing_from_ething(self, et):
        t=apply(thing,(),et.kw)
        t.id=et.id
        try:
            t.type=et.type
        except AttributeError:
            t.type="thing"
        t.kw=et.kw
        t.__dict__.update(t.kw)
        if type(t.place)==StringType and t.place[0]=='_':
            if self.things.has_key(t.place):
                t.place=self.things[t.place]
            else:
                raise id_unknown, t.place
        self.things[t.id]=t
        return t
    def make_temp_thing(self, id):
        try:
            return self.things[id]
        except KeyError:
            self.things[id]=thing(name=id)
            return self.things[id]
