""" vmind.py
 Copyright (C) 1998 Aloril
 
 This program is free software; you can redistribute it and/or modify
 it under the terms of the GNU General Public License as published by
 the Free Software Foundation; either version 2 of the License, or
 (at your option) any later version.
 
 This program is distributed in the hope that it will be useful,
 but WITHOUT ANY WARRANTY; without even the implied warranty of
 MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 GNU General Public License for more details.
 
 You should have received a copy of the GNU General Public License
 along with this program; if not, write to the Free Software
 Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
"""

import const
from thing import thing
from mem_map import mem_map
from event import *

class vmind(thing):
    "base for npc and pc minds"
    def __init__(self,id):
        thing.__init__(self,name=id)
        self.map=mem_map()
        self.illegal_thing=thing(name="illegal",place=None,xyz=(0,0,0))
    def find_thing_by_id(self, id):
        if self.map.things.has_key(id):
            return self.map.things[id]
        raise id_unknown, id
    def replace_illegal_with_destroy(self, input):
        for e in input:
            if e.command=="illegal" and e.what_desc=="id":
                #CHEAT! What if NPC dies giving some thing?
                #       This mind won't notice it.
                id=e.what
                e.command="destroy"
                e.what=self.map.make_temp_thing(e.what)
    def receive_events(self,time,input):
        if const.use_string_events: input=eval(input)
        self.replace_illegal_with_destroy(input)
        if not self.map.things.has_key(self.id):
            self.map.things[self.id]=self
        try:
            self.map.update(input)
            events_replace_id_with_thing(self,input)
        except id_unknown, (id, ev):
            
            return [event("look",what=id)]
        output=self.run_step(time,input)
        if const.use_string_events: return `output`
        return events_replace_thing_with_id(self,output)
